## vdev 1.3.68

=== Makefile ===
include buildconf.mk

.PHONY: all
all:
	$(MAKE) -C libvdev PREFIX=
	$(MAKE) -C vdevd PREFIX=
	$(MAKE) -C fs PREFIX=
	$(MAKE) -C hwdb PREFIX=
	$(MAKE) -C example PREFIX=

.PHONY: install
install:
	$(MAKE) -C vdevd install PREFIX=
	$(MAKE) -C fs install PREFIX=
	$(MAKE) -C hwdb install PREFIX=
	$(MAKE) -C example install PREFIX=

	# Installing documentation
	mkdir -p $(DESTDIR)/usr/share/doc
	mkdir -p $(DESTDIR)/usr/share/man
	mkdir -p $(DESTDIR)/usr/share/man/man8
	cp -r share/doc/ $(DESTDIR)/usr/share/doc
	cp -r share/man/man8/ $(DESTDIR)/usr/share/man/man8

.PHONY: uninstall
uninstall:
	$(MAKE) -C vdevd uninstall
	$(MAKE) -C fs uninstall
	$(MAKE) -C example uninstall
	$(MAKE) -C hwdb uninstall

	# Uninstalling documentation
	rm -rf $(DESTDIR)/usr/share/doc/vdevd
	rm -rf $(DESTDIR)/usr/share/man/man8/vdevd.8.gz
	rm -rf $(DESTDIR)/usr/share/man/man8/vdevd-actions.8.gz

.PHONY: clean
clean:
	$(MAKE) -C libvdev clean
	$(MAKE) -C vdevd clean
	$(MAKE) -C fs clean
	$(MAKE) -C example clean
	$(MAKE) -C hwdb clean

=== libvdev/Makefile ===
include ../buildconf.mk

CFLAGS := -Wall -g -fPIC -fstack-protector -fstack-protector-all -pthread -Wno-unused-variable -Wno-unused-but-set-variable
INC := $(INC) -I$(BUILD_LIBVDEV_HEADERS)
DEFS := $(DEFS) -D_POSIX_C_SOURCE=200809L -D_DEFAULT_SOURCE -D_GNU_SOURCE
CC   := cc

C_SRCS:= $(wildcard *.c)
HEADERS := $(wildcard *.h)

OBJS := $(patsubst %.c,$(BUILD_LIBVDEV)/%.o,$(C_SRCS))

LIBVDEV := $(BUILD_LIBVDEV)/libvdev.a

all: $(LIBVDEV)

$(BUILD_LIBVDEV)/%.o: %.c $(LIBVDEV_HEADERS)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(INC) $(DEFS) -o "$@" -c "$<"

$(LIBVDEV): $(OBJS)
	ar -rcs $@ $^

.PHONY: clean

clean:
	rm -f $(OBJS) $(LIBVDEV)

=== vdevd/Makefile ===
include ../buildconf.mk

C_SRCS := $(wildcard *.c) $(wildcard os/*.c) $(wildcard ../libvdev/*.c)

LIB   := -lpthread -lrt
OBJ   := $(patsubst %.c,$(BUILD_VDEVD)/%.o,$(C_SRCS))
VDEVD := $(BUILD_VDEVD)/vdevd

MANPAGES_INSTALL := $(patsubst debian/%,$(INSTALL_MAN8DIR)/%.gz,$(wildcard debian/*.8))

VDEVD_INSTALL := $(INSTALL_VDEVD)/vdevd

HELPERS_DIR := helpers/$(OS)

HWDB_DIR := $(ROOT_DIR)/hwdb

all: $(VDEVD) helpers

$(VDEVD): $(OBJ) helpers
	@mkdir -p "$(shell dirname "$@")"
	$(CC) -o $@ $(OBJ) $(LIB) $(LIBINC) $(LDFLAGS)

$(BUILD_VDEVD)/%.o : %.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"

$(BUILD_LIBVDEV)/%.o: $(LIBVDEV_ROOT)/%.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"

$(BUILD_MAN8DIR):
	@echo "===== MKDIR $@"
	@mkdir -p $@

$(BUILD_MAN8DIR)/%.gz: debian/% | $(BUILD_MAN8DIR)
	gzip < $< > $@

$(INSTALL_MAN8DIR):
	@mkdir -p $@

$(INSTALL_MAN8DIR)/%: $(BUILD_MAN8DIR)/% | $(INSTALL_MAN8DIR)
	@cp $< $@

.PHONY: helpers
helpers:
	$(MAKE) -C $(HELPERS_DIR)

.PHONY: helpers-install hwdb-install
helpers-install:
	$(MAKE) -C $(HELPERS_DIR) install

hwdb-install:
	$(MAKE) -C $(HWDB_DIR) install

conf-install:
	$(MAKE) -C ../example -f conf.mk conf-install

install: $(VDEVD_INSTALL) helpers-install hwdb-install $(MANPAGES_INSTALL) \
	conf-install

$(VDEVD_INSTALL): $(VDEVD)
	@mkdir -p $(INSTALL_VDEVD)
	@rm -f "$@"
	cp -a "$<" "$@"

.PHONY: clean
clean:
	rm -f $(OBJ) $(VDEVD)
	$(MAKE) -C $(HELPERS_DIR) clean

.PHONY: uninstall
uninstall:
	rm -f $(VDEVD)
	$(MAKE) -C $(HELPERS_DIR) uninstall

=== vdevd/helpers/LINUX/Makefile ===
include ../../../buildconf.mk

C_SRCS:= $(wildcard *.c)
CXSRCS:= $(wildcard *.cpp)
OBJ   := $(patsubst %.c,$(BUILD_VDEVD_HELPERS)/%.o,$(C_SRCS)) $(patsubst %.cpp,$(BUILD_VDEVD_HELPERS)/%.o,$(CXSRCS))
LIB   := -lrt -lblkid `pkg-config --libs libudev libevdev libinput` -L$(BUILD_LIBVDEV) -lvdev
CFLAGS += `pkg-config --cflags libudev libevdev libinput`

HELPER_SCRIPTS := $(wildcard *.sh) daemonlet
HELPERS := stat_optical stat_ata stat_input stat_scsi stat_v4l stat_net stat_usb stat_bus stat_path event-put echo_n cdrom_id vdev_block_info vdev_modprobe vdev_bind_input_devices vdev_reset_usb_devices vdev_print_input_devices vdev_root_sys_block vdev_wait vdev_killall $(HELPER_SCRIPTS)

HELPERS_BUILD := $(patsubst %,$(BUILD_VDEVD_HELPERS)/%,$(HELPERS))
HELPERS_INSTALL := $(patsubst %,$(INSTALL_VDEVD_HELPERS)/%,$(HELPERS))

all: $(HELPERS_BUILD)

$(BUILD_VDEVD_HELPERS)/%: $(BUILD_VDEVD_HELPERS)/%.o $(BUILD_VDEVD_HELPERS)/common.o
	@mkdir -p "$(shell dirname "$@")"
	$(CC) -o "$@" "$<" $(BUILD_VDEVD_HELPERS)/common.o $(LIBINC) $(LIB) $(LDFLAGS)

$(BUILD_VDEVD_HELPERS)/%.o: %.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) -D_GNU_SOURCE $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"

$(BUILD_VDEVD_HELPERS)/%.sh: %.sh
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(BUILD_VDEVD_HELPERS)/daemonlet: daemonlet
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

install: $(HELPERS_INSTALL)
$(INSTALL_VDEVD_HELPERS)/%: $(BUILD_VDEVD_HELPERS)/%
	@mkdir -p "$(shell dirname "$@")"
	@rm -f "$@"
	cp -a "$<" "$@"

.PHONY: uninstall
uninstall:
	rm -f $(HELPERS_INSTALL)

.PHONY: clean
clean:
	rm -f $(OBJ) $(HELPERS_BUILD)

=== debian/changelog ===
vdev (1.3.68-1+genuen6u1) unstable; urgency=medium

  * Remove the shared library libvdev for security reasons and
    instead link the helper programs against a static library
  * Update hardware database
  * New upstream version 1.3.68

 -- Aitor <aitor@genuen.org>  Mon, 29 Dec 2025 23:07:17 +0100

=== debian/control ===
Source: vdev
Section: admin
Priority: optional
Maintainer: Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
Uploaders: Jude Nelson <judecn@devuan.org>
Origin: Gnuinos
Standards-Version: 4.3.0
Homepage: http://judecnelson.blogspot.com
X-Python-Version: >= 2.7
XS-Testsuite: autopkgtest
Build-Depends: debhelper (>= 12),
               build-essential,
               pkg-config,
               dh-runit (>= 2.8.8),
               libudev-compat-dev (>= 3.2.15-1~),
               libfuse-dev (>=2.9.3-15),
               libfskit-dev (>=1.0.2),
               libfskit-fuse-dev (>=1.0.2),
               libpstat-dev (>=0.3-1),
               libblkid-dev (>=2.36.1~),
               libinput-dev (>=1.22.1~),
               libevdev-dev (>=1.13.0~),
               squashfs-tools,
               rsync

Package: vdev
Section: admin
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libudev1-compat (>= 3.2.15-1~),
         libudev-compat-helpers (>= 3.2.15-1~),
         eventfs (>= 0.2-1~),
         util-linux,
         dmidecode,
         sed,
         grep,
         fuse3,
         dash,
         kmod,
         dmsetup,
         iproute2,
Recommends: lvm2
Provides: udev (= 1:3.2.9+devuan4)
Conflicts: udev (<< 1:3.2.9), hal, eudev
Replaces: udev (>= 215),
          bash-completion (<< 1:2.1)
Breaks: libvdev1 (<< 1.3.67)
Pre-Depends: build-essential, ${misc:Pre-Depends}
Description: Portable userspace device-file manager.
 Vdev is a new type of device-file manager for *nix that offers per-process
 access controls to device nodes in a portable manner: it offers
 per-process access controls and is portable to most modern UNICES.
 .
 Vdev sticks to a principled design, whereby the filesystem itself is the API,
 the shell is the inter-service glue, and anything is allowed to be a device event source.
 In doing so, vdev offers a simple but powerful model presenting
 per-process views of the host's devices to different programs.
 .
 This package provides the runtime daemon for using vdev as /dev
 manager (the backend device listener), and the actions.

Package: vdevfs
Section: libs
Architecture: linux-any
Multi-Arch: foreign
Recommends: libpstat-util (>= 0.2-1)
Depends: ${shlibs:Depends},
	 ${misc:Depends},
	 libfuse2 (>= 2.9.3-15+deb8u1),
	 libfskit (>= 1.0.2),
	 libpstat1 (>= 0.2-1),
Description: Frontend filesystem and access control.
 Since POSIX permission bits are insufficient for per-process access control,
 vdevfs defines its own notion of an ACL. Now, it's not enough to simply hide devices
 from some processes and not others; vdevfs must be able to equivocate about what it
 knows about devices-namely, the device's permission bits, owner, and group.
 .
 For example, programs in a user's login session should see the device nodes
 that correspond to a user's seat's input devices and video card as owned by
 and accessible to the user, for the duration of the session.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DESTDIR = /usr

%:
	dh $@ --with runit

override_dh_auto_install:
	rsync -a example/actions/*.act debian/vdev/etc/vdev/actions/
	dh_auto_install

override_dh_installinit:
	dh_installinit --no-start
	dh_installinit --no-start --init-script=vdev-modprobe.sh

override_dh_link:
	dh_link /etc/init.d/vdev /etc/rcS.d/S02vdev
	dh_link /etc/init.d/vdev-modprobe.sh /etc/rcS.d/S01vdev-modprobe.sh
